Index: build.xml
===================================================================
--- build.xml	(revision 5175)
+++ build.xml	(revision 5176)
@@ -265,7 +265,16 @@
 			value="https://code.ecoinformatics.org/code/utilities/${utilities-tag}" />
 		<property name="svn.ecogridUrl"
 			value="https://code.ecoinformatics.org/code/seek/trunk/projects/ecogrid/" />
-		<!--  property name="svn.utilitiesExportPath" value="${knbdir}" / -->
+		<property name="svn.emlBetaUrl"
+			value="https://code.ecoinformatics.org/code/eml/branches/${eml-beta-tag}" />
+		<property name="svn.eml200SchemaUrl"
+			value="https://code.ecoinformatics.org/code/eml/tags/${eml2_0_0-schema-tag}" />
+		<property name="svn.eml201SchemaUrl"
+			value="https://code.ecoinformatics.org/code/eml/tags/${eml2_0_1-schema-tag}" />
+		<property name="svn.eml210SchemaUrl"
+			value="https://code.ecoinformatics.org/code/eml/tags/${eml2_1_0-schema-tag}" />
+		<property name="svn.eml2StyleUrl"
+			value="https://code.ecoinformatics.org/code/eml/tags/${eml2-style-tag}" />
 
 		<!-- load the svn task -->
 		<path id="svn.classpath">
@@ -401,10 +410,7 @@
 	<target name="getpeerutilities" depends="prepare"
 		if="peer.utilities.required"
 		description="Checks utilities out of svn and copies it to your utilitiesdir if it does not already exist">
-		<echo message="Exporting utiities files from svn repository:" />
-		<!-- input message="Please enter svn repo username:" addproperty="svn.username" / -->
-		<!-- input message="Please enter svn repo password:" addproperty="svn.password" / -->
-		<!--  svn username="${svn.username}" password="${svn.password}" -->
+		<echo message="Exporting utilities files from svn repository:" />
 		<svn>
 			<export srcUrl="${svn.utilitiesUrl}"
 				destPath="${utilitiesdir}" />
@@ -414,7 +420,7 @@
 	</target>
 
 	<target name="getutilities" depends="prepare"
-		description="Checks utility out of svn and copies it to your metacat cvs sandbox">
+		description="Checks utility out of svn and copies it to your metacat sandbox">
 		<svn>
 			<export srcUrl="${svn.utilitiesUrl}"
 				destPath="${utilitiesdir}" />
@@ -490,14 +496,15 @@
 		if="eml.required" description="Calls getemlpre2 and geteml2+ targets" />
 
 	<target name="getemlpre2" depends="prepare" if="eml.required"
-		description="Checks EML-beta6 out of cvs and copies dtds and xsl to your metacat cvs sandbox">
-		<echo>Enter CVS password:</echo>
-		<cvs cvsRoot="${cvsroot}" package="${eml-module}"
-			tag="${eml-beta-tag}" dest="${build.tmp}/eml_${eml-beta-tag}" />
+		description="Checks EML-beta6 out of svn and copies dtds and xsl to your metacat sandbox">
+		<svn>
+			<export srcUrl="${svn.emlBetaUrl}"
+				destPath="${build.tmp}/eml_${eml-beta-tag}" />
+		</svn>
 		<mkdir dir="lib/dtd" />
 		<copy todir="lib/dtd" filtering="yes">
 			<fileset
-				dir="${build.tmp}/eml_${eml-beta-tag}/${eml-module}">
+				dir="${build.tmp}/eml_${eml-beta-tag}">
 				<include name="*.dtd" />
 			</fileset>
 			<mapper type="glob" from="eml-*.dtd"
@@ -506,7 +513,7 @@
 
 		<copy todir="${style-common-cvsrelpath}" filtering="yes">
 			<fileset
-				dir="${build.tmp}/eml_${eml-beta-tag}/${eml-module}/style">
+				dir="${build.tmp}/eml_${eml-beta-tag}/style">
 				<include name="**/*.xsl" />
 			</fileset>
 		</copy>
@@ -513,15 +520,15 @@
 	</target>
 
 	<target name="geteml2+" depends="prepare" if="eml.required"
-		description="Checks eml-2 out of cvs and copies schema and xsl to your metacat cvs sandbox">
-		<echo>Enter CVS password:</echo>
-		<cvs cvsRoot="${cvsroot}" package="${eml-module}"
-			tag="${eml2_0_0-schema-tag}"
-			dest="${build.tmp}/eml_${eml2_0_0-schema-tag}" />
+		description="Checks eml-2 out of svn and copies schema and xsl to your metacat sandbox">
+		<svn>
+			<export srcUrl="${svn.eml200SchemaUrl}"
+				destPath="${build.tmp}/eml_${eml2_0_0-schema-tag}" />
+		</svn>
 		<mkdir dir="lib/schema/eml-2.0.0" />
 		<copy todir="lib/schema/eml-2.0.0" filtering="yes">
 			<fileset
-				dir="${build.tmp}/eml_${eml2_0_0-schema-tag}/${eml-module}">
+				dir="${build.tmp}/eml_${eml2_0_0-schema-tag}">
 				<include name="*.xsd" />
 			</fileset>
 
@@ -538,14 +545,14 @@
 			</antcall> -->
 
 		<!-- Checkout eml201 for given schema tag-->
-		<echo>Enter CVS password:</echo>
-		<cvs cvsRoot="${cvsroot}" package="${eml-module}"
-			tag="${eml2_0_1-schema-tag}"
-			dest="${build.tmp}/eml_${eml2_0_1-schema-tag}" />
+		<svn>
+			<export srcUrl="${svn.eml201SchemaUrl}"
+				destPath="${build.tmp}/eml_${eml2_0_1-schema-tag}" />
+		</svn>
 		<mkdir dir="lib/schema/eml-2.0.1" />
 		<copy todir="lib/schema/eml-2.0.1" filtering="yes">
 			<fileset
-				dir="${build.tmp}/eml_${eml2_0_1-schema-tag}/${eml-module}">
+				dir="${build.tmp}/eml_${eml2_0_1-schema-tag}">
 				<include name="*.xsd" />
 			</fileset>
 		</copy>
@@ -562,22 +569,23 @@
 			</antcall -->
 
 		<!-- Checkout eml210 for given schema tag-->
-		<echo>Enter CVS password:</echo>
-		<cvs cvsRoot="${cvsroot}" package="${eml-module}"
-			tag="${eml2_1_0-schema-tag}"
-			dest="${build.tmp}/eml_${eml2_1_0-schema-tag}" />
+		<svn>
+			<export srcUrl="${svn.eml210SchemaUrl}"
+				destPath="${build.tmp}/eml_${eml2_1_0-schema-tag}" />
+		</svn>
 		<mkdir dir="lib/schema/eml-2.1.0" />
 		<copy todir="lib/schema/eml-2.1.0" filtering="yes">
 			<fileset
-				dir="${build.tmp}/eml_${eml2_1_0-schema-tag}/${eml-module}">
+				dir="${build.tmp}/eml_${eml2_1_0-schema-tag}">
 				<include name="*.xsd" />
 			</fileset>
 		</copy>
 
 		<!-- Checkout eml210 for given style sheet tag-->
-		<echo>Enter CVS password:</echo>
-		<cvs cvsRoot="${cvsroot}" package="${eml-module}"
-			tag="${eml2-style-tag}" dest="${build.tmp}/eml_${eml2-style-tag}" />
+		<svn>
+			<export srcUrl="${svn.eml2StyleUrl}"
+				destPath="${build.tmp}/eml_${eml2-style-tag}" />
+		</svn>
 		<antcall target="copyxsl">
 			<param name="cvs.tagname" value="${eml2-style-tag}" />
 			<!-- param name="dirname" value="eml-2.1.0" / -->
@@ -586,7 +594,7 @@
 	</target>
 
 	<target name="copyxsl"
-		description="Copies xsl stylesheets from checkout in build/tmp to your metacat cvs sandbox">
+		description="Copies xsl stylesheets from checkout in build/tmp to your metacat sandbox">
 
 		<delete file="${style-common-cvsrelpath}/${eml-css}" />
 
@@ -593,7 +601,7 @@
 		<copy todir="${style-common-cvsrelpath}/${dirname}"
 			filtering="yes">
 			<fileset
-				dir="${build.tmp}/eml_${cvs.tagname}/${eml-module}/style/eml">
+				dir="${build.tmp}/eml_${cvs.tagname}/style/eml">
 				<include name="**/*.xsl" />
 			</fileset>
 		</copy>
@@ -602,7 +610,7 @@
 		<!-- now copy default css from eml module and put it in style-common-path
 			dir with a new name, so other skin-specific css can import it if reqd -->
 		<copy
-			file="${build.tmp}/eml_${cvs.tagname}/${eml-module}/${eml-module.default.css}"
+			file="${build.tmp}/eml_${cvs.tagname}/${eml-module.default.css}"
 			tofile="${style-common-cvsrelpath}/${eml-css}" />
 
 	</target>
@@ -962,14 +970,15 @@
 		unless="styles.not.needed"
 		description="Gets the conversion stylesheets for eml2 beta 6 to eml 2.0.0">
 
-		<echo>Enter CVS password:</echo>
-		<cvs cvsRoot="${cvsroot}" package="${eml-module}"
-			tag="${eml2-style-tag}" dest="${build.tmp}/eml_${eml2-style-tag}" />
+		<svn>
+			<export srcUrl="${svn.eml2StyleUrl}"
+				destPath="${build.tmp}/conv_eml_${eml2-style-tag}" />
+		</svn>
 
 		<mkdir dir="lib/style/common/emlb6toeml2" />
 		<copy todir="lib/style/common/emlb6toeml2" filtering="yes">
 			<fileset
-				dir="${build.tmp}/eml_${eml2-style-tag}/${eml-module}/lib/beta6toeml2/xsl">
+				dir="${build.tmp}/conv_eml_${eml2-style-tag}/lib/beta6toeml2/xsl">
 				<include name="*.xsl" />
 				<include name="*.xml" />
 			</fileset>