Index: lib/style/skins/sanparks/searchWorkflowRun.jsp
===================================================================
--- lib/style/skins/sanparks/searchWorkflowRun.jsp	(revision 5186)
+++ lib/style/skins/sanparks/searchWorkflowRun.jsp	(revision 5187)
@@ -36,7 +36,7 @@
         <link rel="stylesheet" type="text/css" href="<%=STYLE_SKINS_URL%>/sanparks/footer2.css"/>
         <script language="JavaScript" type="text/JavaScript" src="<%=STYLE_SKINS_URL%>/sanparks/sanparks.js"></script>
         <script language="JavaScript" type="text/JavaScript" src="<%=STYLE_COMMON_URL%>/style/skins/sanparks/searchWorkflowPathQuery.js"></script>
-        <script language="JavaScript" type="text/JavaScript" src="<%=STYLE_COMMON_URL%>/branding.js">
+        <script language="JavaScript" type="text/JavaScript" src="<%=STYLE_COMMON_URL%>/branding.js"></script>
 		<script language="JavaScript" type="text/JavaScript" src="<%=STYLE_COMMON_URL%>/widgets/form-fields-widget.js"></script>
 		<script language="JavaScript" type="text/JavaScript" src="<%=STYLE_COMMON_URL%>/prototype-1.5.1.1/prototype.js"></script>
 		<script language="JavaScript" type="text/JavaScript" src="<%=STYLE_COMMON_URL%>/ajax-utils.js"></script>
@@ -73,7 +73,7 @@
      									<td><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_ne.jpg" /></td>
      								</tr>
      								<tr>
-     									<td><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_w.jpg" /></td>
+     									<td class="search-box-w"><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_w.jpg" /></td>
      									<td>
   
 							        		<form name="tpcSearch" id="tpcSearch">
@@ -92,15 +92,15 @@
 %>		
 												<div class="form-base-row" id="form-base-row">
 													<div class="field-label dropdown-field-label" id='field-selector-section' >Add search term</div>
-													<select class="dropdown-input" name="dd-field-selector" id="dd-field-selector">
-														<option value="name" onclick="addSearchDropdownBefore('tpcSearch','Name','name','co|eq|sw|ew','form-base-row')">Name</option>
-														<option value="keyword" onclick="addSearchDropdownBefore('tpcSearch','Keyword','keyword','co|eq|sw|ew','form-base-row')">Keyword</option>
-														<option values="creator" onclick="addSearchDropdownBefore('tpcSearch','Creator','creator','co|eq|sw|ew','form-base-row')">Creator</option>
-														<option values="description" onclick="addSearchDropdownBefore('tpcSearch','Description','description','co|eq|sw|ew','form-base-row')">Description</option>
-														<option values="date-executed" onclick="addSearchDropdownBefore('tpcSearch','Date Executed','date-executed','be|af','form-base-row')">Date Executed</option>
-														<option values="workflow-run-id" onclick="addSearchDropdownBefore('tpcSearch','Workflow-id','workflow-id','co|eq|sw|ew','form-base-row')">Workflow Run ID</option>
-														<option values="workflow-lsid" onclick="addSearchDropdownBefore('tpcSearch','Workflow-id','workflow-id','co|eq|sw|ew','form-base-row')">Workflow ID</option>
-														<option values="status" onclick="addSearchDropdownBefore('tpcSearch','Status','Status','is|in','form-base-row')">Status</option>
+													<select class="dropdown-input" name="dd-field-selector" id="dd-field-selector" onchange="addSearchDropdownBefore(this)">
+														<option value="name">Name</option>
+														<option value="keyword">Keyword</option>
+														<option value="creator">Creator</option>
+														<option value="description">Description</option>
+														<option value="date-executed">Date Executed</option>
+														<option value="workflow-run-id">Workflow Run ID</option>
+														<option value="workflow-lsid">Workflow ID</option>
+														<option value="status">Status</option>
 													</select>    
 							        		
 							        				<input class="submit-button" value="Search" type="button" onclick="setWorkflowQueryFormField('tpcSearch');submitFormIntoDiv('<%=SERVLET_URL%>','tpcSearch','workflow-search-results')">
Index: lib/style/skins/sanparks/searchWorkflow.jsp
===================================================================
--- lib/style/skins/sanparks/searchWorkflow.jsp	(revision 5186)
+++ lib/style/skins/sanparks/searchWorkflow.jsp	(revision 5187)
@@ -73,7 +73,7 @@
      									<td><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_ne.jpg" /></td>
      								</tr>
      								<tr>
-     									<td><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_w.jpg" /></td>
+     									<td class="search-box-w"><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_w.jpg" /></td>
      									<td>
 			      						  	<form name="tpcSearch" id="tpcSearch">
 			        							<input name="query" id="query" type="hidden" />
@@ -82,19 +82,19 @@
 												<input name="action" value="squery" type="hidden" />  		
 												<div class="form-base-row" id="form-base-row">
 													<div class="field-label dropdown-field-label" id='field-selector-section' >Add search term</div>
-													<select class="dropdown-input" name="dd-field-selector" id="dd-field-selector">
-														<option value="name" onclick="addSearchDropdownBefore('tpcSearch','Name','name','co|eq|sw|ew','form-base-row')">Name</option>
-														<option value="keyword" onclick="addSearchDropdownBefore('tpcSearch','Keyword','keyword','co|eq|sw|ew','form-base-row')">Keyword</option>
-														<option values="creator" onclick="addSearchDropdownBefore('tpcSearch','Creator','creator','co|eq|sw|ew','form-base-row')">Creator</option>
-														<option values="description" onclick="addSearchDropdownBefore('tpcSearch','Description','description','co|eq|sw|ew','form-base-row')">Description</option>
-														<option values="date-created" onclick="addSearchDropdownBefore('tpcSearch','Date Created','date-created','be|af','form-base-row')">Date Created</option>
-														<option values="workflow-id" onclick="addSearchDropdownBefore('tpcSearch','Workflow-id','workflow-id','co|eq|sw|ew','form-base-row')">Workflow ID</option>
+													<select class="dropdown-input" name="dd-field-selector" id="dd-field-selector" onchange="addSearchDropdownBefore(this)">
+														<option value="name">Name</option>
+														<option value="keyword">Keyword</option>
+														<option value="creator">Creator</option>
+														<option value="description">Description</option>
+														<option value="date-created">Date Created</option>
+														<option value="workflow-id">Workflow ID</option>
 													</select>         		
 			        								<input class="submit-button" value="Search" type="button" onclick="setWorkflowQueryFormField('tpcSearch');submitFormIntoDiv('<%=SERVLET_URL%>','tpcSearch','workflow-search-results')">
 			        							</div> 
 			        						</form>
         								</td>
-        								<td><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_e.jpg" /></td>
+        								<td class="search-box-e"><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_e.jpg" /></td>
 			        				</tr>
 			        				<tr>
 			     						<td><img src="<%=STYLE_SKINS_URL%>/sanparks/images/search_box_sw.jpg" /></td>
Index: lib/style/skins/sanparks/sanparks-tpc.css
===================================================================
--- lib/style/skins/sanparks/sanparks-tpc.css	(revision 5186)
+++ lib/style/skins/sanparks/sanparks-tpc.css	(revision 5187)
@@ -58,6 +58,14 @@
 	width: 100%;
 }
 
+.search-box-w {
+	background: transparent url("images/search_box_w.jpg") left 0px repeat-y;
+}
+
+.search-box-e {
+	background: transparent url("images/search_box_e.jpg") left 0px repeat-y;
+}
+
 .content-section-header {
 	text-align:	left;
 	color: #124325;
Index: lib/style/common/widgets/form-fields-widget.js
===================================================================
--- lib/style/common/widgets/form-fields-widget.js	(revision 5186)
+++ lib/style/common/widgets/form-fields-widget.js	(revision 5187)
@@ -89,8 +89,33 @@
   	lastInputIndex++;
 }
 
-function addSearchDropdownBefore(formId, inputLabel, inputName,  searchModes, beforeElementId) {
-	// alert('in addDropdownInputBefore - formId: ' + formId + ' inputLabel: ' + inputLabel + ' inputName: ' + inputName + ' searchModes: ' + searchModes + ' beforeElementId: ' + beforeElementId);
+function addSearchDropdownBefore(selectObj) {
+	//alert(selectObj.value);
+	if (selectObj.value == "name") {
+		addSearchSelectionBefore('tpcSearch','Name','name','co|eq|sw|ew','form-base-row');
+	} else if (selectObj.value == "keyword") {
+		addSearchSelectionBefore('tpcSearch','Keyword','keyword','co|eq|sw|ew','form-base-row');
+	} else if (selectObj.value == "creator") {
+		addSearchSelectionBefore('tpcSearch','Creator','creator','co|eq|sw|ew','form-base-row');
+	} else if (selectObj.value == "description") {
+		addSearchSelectionBefore('tpcSearch','Description','description','co|eq|sw|ew','form-base-row');
+	} else if (selectObj.value == "date-executed") {
+		addSearchSelectionBefore('tpcSearch','Date Executed','date-executed','be|af','form-base-row');
+	} else if (selectObj.value == "workflow-run-id") {
+		addSearchSelectionBefore('tpcSearch','Workflow-id','workflow-id','co|eq|sw|ew','form-base-row');
+	} else if (selectObj.value == "workflow-lsid") {
+		addSearchSelectionBefore('tpcSearch','Workflow-id','workflow-id','co|eq|sw|ew','form-base-row');
+	} else if (selectObj.value == "status") {
+		addSearchSelectionBefore('tpcSearch','Status','Status','is|in','form-base-row');
+	} else if (selectObj.value == "date-created") {
+		addSearchSelectionBefore('tpcSearch','Date Created','date-created','be|af','form-base-row');
+	} else if (selectObj.value == "workflow-id") {
+		addSearchSelectionBefore('tpcSearch','Workflow-id','workflow-id','co|eq|sw|ew','form-base-row');
+	}		
+}
+
+function addSearchSelectionBefore(formId, inputLabel, inputName,  searchModes, beforeElementId) {
+	//alert('in addDropdownInputBefore - formId: ' + formId + ' inputLabel: ' + inputLabel + ' inputName: ' + inputName + ' searchModes: ' + searchModes + ' beforeElementId: ' + beforeElementId);
 	var formObj = document.getElementById(formId);
 	var beforeObj = document.getElementById(beforeElementId);
 	var newDiv = document.createElement('div');