Index: src/edu/ucsb/nceas/metacat/DocumentImplWrapper.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImplWrapper.java	(revision 5198)
+++ src/edu/ucsb/nceas/metacat/DocumentImplWrapper.java	(revision 5199)
@@ -38,86 +38,71 @@
  * provide deferent parser base on xml document validation by dtd or schema
  */
 
-public class DocumentImplWrapper
-{
-  
-   /* Attributes */
-   private String    ruleBase               = null;
-   private boolean   needValidation         = false;
-  
-   
-   /**
-    *  Constructor of DocumentImpleWrapper
-    *  @param myRuleBase  the xml is base on DTD or Schema
-    *  @param validation  if the xml document need to be validated
-    */
-  public DocumentImplWrapper(String myRuleBase, boolean validation)
-  {
-     ruleBase       = myRuleBase;
-     needValidation = validation;
-       
-  }//Constructor
+public class DocumentImplWrapper {
 
-  public String write(DBConnection conn, String xml, String pub, Reader dtd,
-                      String action, String docid, String user, String[] groups)
-                      throws Exception
-  {
-    return DocumentImpl.write(conn, xml, pub, dtd, action, docid, user, 
-                              groups, ruleBase, needValidation);
-  }
-  
-  public String writeReplication(DBConnection conn, String xml, 
-                                        String pub, Reader dtd, String action, 
-                                        String accnum, String user,
-                                        String[] groups,String homeServer, 
-                                        String notifyServer, String createDate,
-                                        String updateDate)
-                                        throws Exception
-  {
-    //we don't need to check validation in replication
-    // so rule base is null and need validation is false (first false)
-    // this method is for force replication. so the table name is xml_documents
-     // and timed replication is false (last false)
-    return DocumentImpl.writeReplication(conn, xml, pub, dtd, action, 
-                                        accnum, user, groups, homeServer, 
-                                        notifyServer, ruleBase, false, 
-                                        DocumentImpl.DOCUMENTTABLE, false, 
-                                        createDate, updateDate);
-                                        // last false means is not timed replication
-                         
-  }
-  
-  /**
-   * Constructor with tableName - this doc is in xml_documents or xml_revsions
-   * If in xml_revisions, it need a special handler.
-   * @param conn
-   * @param xml
-   * @param pub
-   * @param dtd
-   * @param action
-   * @param accnum
-   * @param user
-   * @param groups
-   * @param homeServer
-   * @param notifyServer
-   * @param tableName
-   * @return
-   * @throws Exception
-   */
-  public String writeReplication(DBConnection conn, String xml, 
-          String pub, Reader dtd, String action, 
-          String accnum, String user,
-          String[] groups,String homeServer, 
-          String notifyServer, String tableName, 
-          boolean timedReplication, String createDate, String updateDate)
-          throws Exception
-  {
-   //we don't need to check validation in replication
-   // so rule base is null and need validation is false
-   return DocumentImpl.writeReplication(conn, xml, pub, dtd, action, 
-          accnum, user, groups, homeServer, 
-          notifyServer, ruleBase, false, tableName, 
-          timedReplication, createDate, updateDate);
-  }
+	/* Attributes */
+	private String ruleBase = null;
+	private boolean needValidation = false;
 
+	/**
+	 *  Constructor of DocumentImpleWrapper
+	 *  @param myRuleBase  the xml is base on DTD or Schema
+	 *  @param validation  if the xml document need to be validated
+	 */
+	public DocumentImplWrapper(String myRuleBase, boolean validation) {
+		ruleBase = myRuleBase;
+		needValidation = validation;
+
+	}//Constructor
+
+	public String write(DBConnection conn, String xml, String pub, Reader dtd,
+			String action, String docid, String user, String[] groups) throws Exception {
+		return DocumentImpl.write(conn, xml, pub, dtd, action, docid, user, groups,
+				ruleBase, needValidation);
+	}
+
+	public String writeReplication(DBConnection conn, String xml, String pub, Reader dtd,
+			String action, String accnum, String user, String[] groups,
+			String homeServer, String notifyServer, String createDate, String updateDate)
+			throws Exception {
+		//we don't need to check validation in replication
+		// so rule base is null and need validation is false (first false)
+		// this method is for force replication. so the table name is xml_documents
+		// and timed replication is false (last false)
+		return DocumentImpl.writeReplication(conn, xml, pub, dtd, action, accnum, user,
+				groups, homeServer, notifyServer, ruleBase, false,
+				DocumentImpl.DOCUMENTTABLE, false, createDate, updateDate);
+		// last false means is not timed replication
+
+	}
+
+	/**
+	 * Constructor with tableName - this doc is in xml_documents or xml_revsions
+	 * If in xml_revisions, it need a special handler.
+	 * @param conn
+	 * @param xml
+	 * @param pub
+	 * @param dtd
+	 * @param action
+	 * @param accnum
+	 * @param user
+	 * @param groups
+	 * @param homeServer
+	 * @param notifyServer
+	 * @param tableName
+	 * @return
+	 * @throws Exception
+	 */
+	public String writeReplication(DBConnection conn, String xml, String pub, Reader dtd,
+			String action, String accnum, String user, String[] groups,
+			String homeServer, String notifyServer, String tableName,
+			boolean timedReplication, String createDate, String updateDate)
+			throws Exception {
+		//we don't need to check validation in replication
+		// so rule base is null and need validation is false
+		return DocumentImpl.writeReplication(conn, xml, pub, dtd, action, accnum, user,
+				groups, homeServer, notifyServer, ruleBase, false, tableName,
+				timedReplication, createDate, updateDate);
+	}
+
 }