Index: lib/metacat.properties
===================================================================
--- lib/metacat.properties	(revision 5275)
+++ lib/metacat.properties	(revision 5276)
@@ -67,6 +67,7 @@
 database.upgradeVersion.1.9.0=upgrade-db-to-1.9
 database.upgradeVersion.1.9.1=upgrade-db-to-1.9.1
 database.upgradeVersion.1.9.2=upgrade-db-to-1.9.2
+database.upgradeVersion.1.10.0=upgrade-db-to-1.10.0
 database.initialConnections=5
 database.incrementConnections=5
 database.maximumConnections=200
Index: src/xmltables-oracle.sql
===================================================================
--- src/xmltables-oracle.sql	(revision 5275)
+++ src/xmltables-oracle.sql	(revision 5276)
@@ -32,7 +32,6 @@
 DROP SEQUENCE xml_catalog_id_seq;
 DROP SEQUENCE xml_relation_id_seq;
 DROP SEQUENCE xml_replication_id_seq;
-DROP SEQUENCE identifier_id_seq;
 DROP SEQUENCE access_log_id_seq;
 DROP SEQUENCE xml_returnfield_id_seq;
 DROP SEQUENCE xml_queryresult_id_seq;
@@ -45,7 +44,6 @@
 DROP TRIGGER xml_catalog_before_insert;
 DROP TRIGGER xml_relation_before_insert;
 DROP TRIGGER xml_replication_before_insert;
-DROP TRIGGER identifier_before_insert;
 DROP TRIGGER access_log_before_insert;
 DROP TRIGGER xml_returnfield_before_insert;
 DROP TRIGGER xml_queryresult_before_insert;
@@ -396,25 +394,16 @@
 
 /*
  * Table used to store all document identifiers in metacat.  Each identifier
- * consists of 4 subparts, an authority, namespace, object, and revision as
- * defined in the LSID specification.
+ * has a globally unique, unconstrained string, which we will refer to as a
+ * GUID, and a local metacat identifier, which consists of the docid
+ * and revision fields. Each row maps one global identifier to the local
+ * identifier (docid) used within metacat.
  */
-CREATE SEQUENCE identifier_id_seq;
 CREATE TABLE identifier (
-   id        NUMBER(20) PRIMARY KEY, -- primary key
-   authority VARCHAR2(255),  -- the authority issuing the identifier
-   namespace VARCHAR2(255),  -- the namespace qualifying the identifier
-   object    VARCHAR2(255),  -- the local part of the identifier for a particular object
-   revision  VARCHAR2(255)   -- the revision part of the identifier
+   guid   VARCHAR2(2000), -- the globally unique string identifier
+   docid  VARCHAR2(250),  -- the local document id #
+   rev    NUMBER(8)       -- the revision part of the local identifier
 );
-CREATE TRIGGER identifier_before_insert
-BEFORE INSERT ON identifier FOR EACH ROW
-BEGIN
-  SELECT identifier_id_seq.nextval
-    INTO :new.id
-    FROM dual;
-END;
-/
 
 /*
  * accesssubtree -- table to store access subtree info
Index: src/upgrade-db-to-1.10.0-postgres.sql
===================================================================
--- src/upgrade-db-to-1.10.0-postgres.sql	(nonexistent)
+++ src/upgrade-db-to-1.10.0-postgres.sql	(revision 5276)
@@ -0,0 +1,17 @@
+DROP TABLE identifier;
+DROP SEQUENCE identifier_id_seq;
+
+CREATE TABLE identifier (
+   guid   text,          -- the globally unique string identifier
+   docid  VARCHAR(250),  -- the local document id #
+   rev    INT8,          -- the revision part of the local identifier
+   CONSTRAINT identifier_pk PRIMARY KEY (guid)
+);
+
+/*
+ * update the database version
+ */
+UPDATE db_version SET status=0;
+
+INSERT INTO db_version (version, status, date_created) 
+  VALUES ('1.10.0', 1, CURRENT_DATE);
Index: src/xmltables-postgres.sql
===================================================================
--- src/xmltables-postgres.sql	(revision 5275)
+++ src/xmltables-postgres.sql	(revision 5276)
@@ -270,16 +270,16 @@
 
 /*
  * Table used to store all document identifiers in metacat.  Each identifier
- * consists of 4 subparts, an authority, namespace, object, and revision as
- * defined in the LSID specification.
+ * has a globally unique, unconstrained string, which we will refer to as a
+ * GUID, and a local metacat identifier, which consists of the docid
+ * and revision fields. Each row maps one global identifier to the local
+ * identifier (docid) used within metacat.
  */
-CREATE SEQUENCE identifier_id_seq;
 CREATE TABLE identifier (
-   id INT8 default nextval('identifier_id_seq') PRIMARY KEY, -- primary id
-   authority VARCHAR(255),  -- the authority issuing the identifier
-   namespace VARCHAR(255),  -- the namespace qualifying the identifier
-   object    VARCHAR(255),  -- the local part of the identifier for a particular object
-   revision  VARCHAR(255)   -- the revision part of the identifier
+   guid   text,          -- the globally unique string identifier
+   docid  VARCHAR(250),	 -- the local document id #
+   rev    INT8,          -- the revision part of the local identifier
+   CONSTRAINT identifier_pk PRIMARY KEY (guid)
 );
 
 /*
Index: src/upgrade-db-to-1.10.0-oracle.sql
===================================================================
--- src/upgrade-db-to-1.10.0-oracle.sql	(nonexistent)
+++ src/upgrade-db-to-1.10.0-oracle.sql	(revision 5276)
@@ -0,0 +1,24 @@
+DROP SEQUENCE identifier_id_seq;
+DROP TRIGGER identifier_before_insert;
+DROP TABLE identifier;
+
+/*
+ * Table used to store all document identifiers in metacat.  Each identifier
+ * has a globally unique, unconstrained string, which we will refer to as a
+ * GUID, and a local metacat identifier, which consists of the docid
+ * and revision fields. Each row maps one global identifier to the local
+ * identifier (docid) used within metacat.
+ */
+CREATE TABLE identifier (
+   guid   VARCHAR2(2000), -- the globally unique string identifier
+   docid  VARCHAR2(250),  -- the local document id #
+   rev    NUMBER(8)       -- the revision part of the local identifier
+);
+
+/*
+ * update the database version
+ */
+UPDATE db_version SET status=0;
+
+INSERT INTO db_version (version, status, date_created) 
+  VALUES ('1.10.0', 1, CURRENT_DATE);
Index: build.properties
===================================================================
--- build.properties	(revision 5275)
+++ build.properties	(revision 5276)
@@ -2,7 +2,7 @@
 
 #Version of this build.  This needs to be a dotted numeric version.  For
 #instance 1.9.1 is okay.  1.9.1_rc1 is not.
-metacat.version=1.9.2
+metacat.version=1.10.0
 
 #This is for packaging purposes.  leave it blank for final production release.
 metacat.releaseCandidate=-6